# Roo Code 3.11.9 Release Notes (2025-04-07)

This patch release introduces per-profile rate limits, multiple rules file support, provider updates, API additions, and various improvements and bug fixes.
## Custom Roo Instructions (`.roo/` Directories)

*   Introduced support for placing multiple instruction files within `.roo/rules/` (for workspace-wide) and `.roo/rules-{modeSlug}/` (for mode-specific) directories. Roo Code recursively reads all files within these directories, appending them to the system prompt in **alphabetical order** by filename.
*   This allows for better organization and management of complex instruction sets compared to single files.
*   This directory-based method now takes precedence over the single `.roorules` or `.roorules-{modeSlug}` files if the corresponding directory exists and contains files. (Thanks upamune!)
*   Learn more about [Custom Instructions](/features/custom-instructions) and how this applies to [Custom Modes](/features/custom-modes).

## Per-Profile Rate Limits

*   The **Rate Limit** setting is now configured individually for each [API Configuration Profile](/features/api-configuration-profiles). Previously a global setting, this allows you to set different minimum delays between requests based on the provider, model, or specific profile setup you are using. (Thanks ross and olweraltuve!)
*   The default remains 0 (disabled), which is suitable for most users.
*   Configure this setting within each profile's options. See the [API Configuration Profiles](/features/api-configuration-profiles#creating-a-profile) guide for details. General information on usage tracking is available in [Rate Limits and Costs](/advanced-usage/rate-limits-costs).


## General and QOL Improvements

*   Tidied up following ClineProvider refactor (thanks diarmidmackenzie!).
*   Enhanced Rust tree-sitter parser with advanced language structures (thanks KJ7LNW!).
*   Persisted settings on `api.setConfiguration` (thanks gtaylor!).
*   Added deep links to settings sections.
*   Added command to focus Roo Code input field (thanks axkirillov!).
*   Added resize and hover actions to the browser (thanks SplittyDev!).
*   Added `resumeTask` and `isTaskInHistory` to the API (thanks franekp!).
*   Dynamic Vite port detection for webview development (thanks KJ7LNW!).

## Bug Fixes

*   Prevented unnecessary autoscroll when buttons appear (thanks shtse8!).
*   Clamped negative line numbers when reading files (thanks KJ7LNW!).
*   Fixed bug displaying boolean/numeric suggested answers.

## Provider Updates

*   Added Gemini 2.5 Pro Preview to Vertex AI (thanks nbihan-mediware!).